%==========================================================================
%Example: A model of hedgehog signaling pathway (HSP)
%--------------------------------------------------------------------------
%-------The inputs of the model reduction----------------------------------
%---------Z: the sxc complex composition matrix----------------------------
%---------B: the cxr incidence matrix--------------------------------------
%---------k: the vector of rate constants of of length r-------------------
%---------x_0: the vector of initial concentrations of length s------------
%---------Maximum_error: the maximum admissible value of the error integral
%==========================================================================
Z = [0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0;    
     0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0;    
     0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0;    
     0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;    
     0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0;    
     0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0;    
     0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0;    
     0 0 0 0 0 0 1 0 0 0 0 1 0 0 0 0 0 0;    
     0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0;    
     0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 1 0;    
     0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0;    
     0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0;    
     0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0;    
     0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0;    
     1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;    
     0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0;    
     0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0;    
     0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;  
     0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0;  
     0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 1;  
     0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0];  
%--------------------------------------------------------------------------          
 B= [-1  1  0  0  0  0  0  1 -1  0  0  0  0  0  0  0  0  0  0  0; 
     1 -1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0; 
     0  0 -1  0  0  0  0  0  0  0  0  0  0  0  1 -1  0  0  0  0; 
     0  0  0 -1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  1 -1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  0  0 -1  1  0  0  0  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  1 -1  0  0  0  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  0  0 -1  1  0  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0 -1  0  0  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  1  0  0 -1  1  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  0  1 -1  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  0 -1  1  0  0  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  0  0  0  1 -1  0  0  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  0  0  0  0  0 -1  1  0  0  0  0; 
     0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1 -1  0  0; 
     0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0 -1  1  0  0; 
     0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1 -1; 
     0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0 -1  1];
%--------------------------------------------------------------------------          
k  = [0.6; 1.67; 1.560; 1.130; 1.122; 1.146; 1.750; 1.230; 0.460; 0.5; 
     1.530; 0.890; 1; 1; 1.280; 0.710; 1.330; 0.610; 1.270; 0.730];
%--------------------------------------------------------------------------          
x_0 = [2; 0; 5; 0; 2.5; 5; 0; 0; 0; 0; 0; 2; 0; 2.5; 0; 3; 3; 0; 0; 0; 0];
%--------------------------------------------------------------------------
        Maximum_error = 0.15;
%-------------------------------------------------------------------------- 
save('HSP')
%==========================================================================
